﻿using System;
using System.Linq;
using System.IO.Ports;
using System.Threading.Tasks;
using System.Runtime.InteropServices;
using System.Security.Policy;

/* KeiganMotor API
 * 
 * Send Command to KeiganMotor
 * 
 */

public partial class KeiganMotor_USB
{

    public byte[] ReadPIDParams()
    {
        byte[] param = new byte[5];
        int size = 0;

        //パラメータのセット
        param[size++] = 0x42; // readPIDParams コマンド

        GetIDBytes().CopyTo(param, size);
        size += 2;


        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }


    //public byte[] ReadDeviceName()
    //{
    //    byte[] param = new byte[5];
    //    int size = 0;

    //    //パラメータのセット
    //    param[size++] = 0x46; // readDeviceName コマンド

    //    GetIDBytes().CopyTo(param, size);
    //    size += 2;


    //    GetCRC16Bytes(param, size).CopyTo(param, size);
    //    size += 2;

    //    if (serialPort.IsOpen == true)
    //    {
    //        serialPort.Write(param, 0, size);
    //    }
    //    return param;
    //}

    //public byte[] ReadDeviceInfo()
    //{
    //    byte[] param = new byte[5];
    //    int size = 0;

    //    //パラメータのセット
    //    param[size++] = 0x47; // readDeviceInfo コマンド

    //    GetIDBytes().CopyTo(param, size);
    //    size += 2;


    //    GetCRC16Bytes(param, size).CopyTo(param, size);
    //    size += 2;

    //    if (serialPort.IsOpen == true)
    //    {
    //        serialPort.Write(param, 0, size);
    //    }
    //    return param;
    //}
    public byte[] ReadAllInfo()
    {
        byte[] param = new byte[5];
        int size = 0;

        //パラメータのセット
        param[size++] = 0x49; // readAllInfo コマンド

        GetIDBytes().CopyTo(param, size);
        size += 2;


        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }


  
    // Registers

    public byte[] CurveType(byte type)
    {
        byte[] param = new byte[6];
        int size = 0;

        //パラメータのセット
        param[size++] = 0x05;

        GetIDBytes().CopyTo(param, size);
        size += 2;

        param[size++] = type;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] Acc(float value)
    {
        byte[] param = new byte[9];
        int size = 0;

        byte[] array = FloatToBytes(value);

        //パラメータのセット
        param[size++] = 0x07;

        GetIDBytes().CopyTo(param, size);
        size += 2;

        array.CopyTo(param, size);
        size += 4;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] Dec(float value)
    {
        byte[] param = new byte[9];
        int size = 0;

        byte[] array = FloatToBytes(value);

        //パラメータのセット
        param[size++] = 0x08;

        GetIDBytes().CopyTo(param, size);
        size += 2;

        array.CopyTo(param, size);
        size += 4;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }


    public byte[] MaxTorque(float value)
    {
        byte[] param = new byte[9];
        int size = 0;

        byte[] array = FloatToBytes(value);

        //パラメータのセット
        param[size++] = 0x0E;

        GetIDBytes().CopyTo(param, size);
        size += 2;

        array.CopyTo(param, size);
        size += 4;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] CurrentQPIDP(float value)
    {
        byte[] param = new byte[9];
        int size = 0;

        // Windows PC　はリトルエンディアンであることに注意。ビッグエンディアンにしてバイト列にする。
        byte[] array = FloatToBytes(value);

        //パラメータのセット
        param[size++] = 0x18;

        GetIDBytes().CopyTo(param, size);
        size += 2;

        array.CopyTo(param, size);
        size += 4;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] CurrentQPIDI(float value)
    {
        byte[] param = new byte[9];
        int size = 0;

        // Windows PC　はリトルエンディアンであることに注意。ビッグエンディアンにしてバイト列にする。
        byte[] array = FloatToBytes(value);

        //パラメータのセット
        param[size++] = 0x19;

        GetIDBytes().CopyTo(param, size);
        size += 2;

        array.CopyTo(param, size);
        size += 4;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }



    public byte[] CurrentQPIDD(float value)
    {
        byte[] param = new byte[9];
        int size = 0;

        // Windows PC　はリトルエンディアンであることに注意。ビッグエンディアンにしてバイト列にする。
        byte[] array = FloatToBytes(value);

        //パラメータのセット
        param[size++] = 0x1A;

        GetIDBytes().CopyTo(param, size);
        size += 2;

        array.CopyTo(param, size);
        size += 4;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }


    public byte[] SpeedPIDP(float value)
    {
        byte[] param = new byte[9];
        int size = 0;

        // Windows PC　はリトルエンディアンであることに注意。ビッグエンディアンにしてバイト列にする。
        byte[] array = FloatToBytes(value);

        //パラメータのセット
        param[size++] = 0x1B;

        GetIDBytes().CopyTo(param, size);
        size += 2;

        array.CopyTo(param, size);
        size += 4;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] SpeedPIDI(float value)
    {
        byte[] param = new byte[9];
        int size = 0;

        // Windows PC　はリトルエンディアンであることに注意。ビッグエンディアンにしてバイト列にする。
        byte[] array = FloatToBytes(value);

        //パラメータのセット
        param[size++] = 0x1C;

        GetIDBytes().CopyTo(param, size);
        size += 2;

        array.CopyTo(param, size);
        size += 4;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }



    public byte[] SpeedPIDD(float value)
    {
        byte[] param = new byte[9];
        int size = 0;

        // Windows PC　はリトルエンディアンであることに注意。ビッグエンディアンにしてバイト列にする。
        byte[] array = FloatToBytes(value);

        //パラメータのセット
        param[size++] = 0x1D;

        GetIDBytes().CopyTo(param, size);
        size += 2;

        array.CopyTo(param, size);
        size += 4;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] PositionPIDP(float value)
    {
        byte[] param = new byte[9];
        int size = 0;

        // Windows PC　はリトルエンディアンであることに注意。ビッグエンディアンにしてバイト列にする。
        byte[] array = FloatToBytes(value);


        //パラメータのセット
        param[size++] = 0x1E; //positionPIDP コマンド

        GetIDBytes().CopyTo(param, size);
        size += 2;

        array.CopyTo(param, size);
        size += 4;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }


    public byte[] PositionPIDI(float value)
    {
        byte[] param = new byte[9];
        int size = 0;

        // Windows PC　はリトルエンディアンであることに注意。ビッグエンディアンにしてバイト列にする。
        byte[] array = FloatToBytes(value);


        //パラメータのセット
        param[size++] = 0x1F; //positionPIDI コマンド

        GetIDBytes().CopyTo(param, size);
        size += 2;

        array.CopyTo(param, size);
        size += 4;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] PositionPIDD(float value)
    {
        byte[] param = new byte[9];
        int size = 0;

        // Windows PC　はリトルエンディアンであることに注意。ビッグエンディアンにしてバイト列にする。
        byte[] array = FloatToBytes(value);


        //パラメータのセット
        param[size++] = 0x20; //positionPIDD コマンド

        GetIDBytes().CopyTo(param, size);
        size += 2;

        array.CopyTo(param, size);
        size += 4;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] PosPIDThreshold(float value)
    {
        byte[] param = new byte[9];
        int size = 0;

        // Windows PC　はリトルエンディアンであることに注意。ビッグエンディアンにしてバイト列にする。
        byte[] array = FloatToBytes(value);


        //パラメータのセット
        param[size++] = 0x21;

        GetIDBytes().CopyTo(param, size);
        size += 2;

        array.CopyTo(param, size);
        size += 4;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] PosArrivalSetting(bool notifyEnabled, float tolerance, UInt32 judgeTime)
    {
        byte[] param = new byte[14];
        int size = 0;

        param[size++] = 0x2B;

        GetIDBytes().CopyTo(param, size);
        size += 2;

        param[size++] = notifyEnabled ? (byte)1:(byte)0;

        byte[] array = FloatToBytes(tolerance);
        array.CopyTo(param, size);
        size += 4;

        byte[] array2 = UInt32ToBytes(judgeTime);
        array2.CopyTo(param, size);
        size += 4;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;

    }



    // Low-pass filter の種類
    public enum LowpassFilterType
    {
        LPFCurrent = 0,
        LPFVelocity = 1,
        LPFPosition = 2
    }

    public byte[] LowPassFilter(LowpassFilterType type, float value)
    {
        byte[] param = new byte[10];
        int size = 0;

        // Windows PC　はリトルエンディアンであることに注意。ビッグエンディアンにしてバイト列にする。
        byte[] array = FloatToBytes(value);


        //パラメータのセット
        param[size++] = 0x27; // LowpassFilter コマンド

        GetIDBytes().CopyTo(param, size);
        size += 2;

        param[size++] = (Byte)type;

        array.CopyTo(param, size);
        size += 4;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }



    // PID の種類
    public enum PIDParamType
    {
        PID_PARAM_Q_CURRENT_P = 0,
        PID_PARAM_Q_CURRENT_I = 1,
        PID_PARAM_Q_CURRENT_D = 2,
        PID_PARAM_Q_CURRENT_LPF_INPUT = 10,
        PID_PARAM_Q_CURRENT_INPUT_GAIN = 11,

        PID_PARAM_VELOCITY_P = 20,
        PID_PARAM_VELOCITY_I = 21,
        PID_PARAM_VELOCITY_D = 22,
        PID_PARAM_VELOCITY_LPF_INPUT = 30,

        PID_PARAM_POSITION_P = 40,
        PID_PARAM_POSITION_I = 41,
        PID_PARAM_POSITION_D = 42,
        PID_PARAM_POSITION_LPF_INPUT = 50,
        PID_PARAM_POSITION_ID_THRESHOLD = 55,

    }

    public byte[] SetPIDTableValue(byte tableIndex, PIDParamType type, float value)
    {
        byte[] param = new byte[11];
        int size = 0;

        //パラメータのセット
        param[size++] = 0x23; // SetPIDTableValue

        GetIDBytes().CopyTo(param, size);
        size += 2;

        param[size++] = tableIndex;
        param[size++] = (byte)type;

        byte[] array = FloatToBytes(value);
        array.CopyTo(param, size);
        size += 4;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] SelectPIDTable(byte tableIndex)
    {
        byte[] param = new byte[6];
        int size = 0;

        //パラメータのセット
        param[size++] = 0x24;

        GetIDBytes().CopyTo(param, size);
        size += 2;

        param[size++] = tableIndex;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] ReadPIDTable(byte tableIndex)
    {
        byte[] param = new byte[6];
        int size = 0;

        //パラメータのセット
        param[size++] = 0x25;

        GetIDBytes().CopyTo(param, size);
        size += 2;

        param[size++] = tableIndex;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] SavePIDTable()
    {
        byte[] param = new byte[5];
        int size = 0;

        //パラメータのセット
        param[size++] = 0x26;

        GetIDBytes().CopyTo(param, size);
        size += 2;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] Interface(bool isBLEEnabled, bool isLinkageEnabled, bool isUARTEnabled, bool isI2CEnabled, bool isDigitalIOEnabled, bool isUART2Enabled, bool isButtonEnabled)
    {
        Console.WriteLine("{0},{1},{2},{3},{4},{5},{6}", isBLEEnabled, isLinkageEnabled, isUARTEnabled, isI2CEnabled, isDigitalIOEnabled, isUART2Enabled, isButtonEnabled);
        byte flag = 0;
        if (isBLEEnabled) flag |= 1; Console.WriteLine("interface flag: {0}", flag);
        if (isLinkageEnabled) flag |= (1 << 1); Console.WriteLine("interface flag: {0}", flag);
        if (isUARTEnabled) flag |= (1 << 3); Console.WriteLine("interface flag: {0}", flag);
        if (isI2CEnabled) flag |= (1 << 4); Console.WriteLine("interface flag: {0}", flag);
        if (isDigitalIOEnabled) flag |= (1 << 5); Console.WriteLine("interface flag: {0}", flag);
        if (isUART2Enabled) flag |= (1 << 6); Console.WriteLine("interface flag: {0}", flag);
        if (isButtonEnabled) flag |= (1 << 7);
        Console.WriteLine("interface flag: {0}", flag);

        return Interface(flag);
    }

    public byte[] Interface(InterfaceSetting intf)
    {
        return Interface(intf.isBLEEnabled, intf.isLinkageEnabled, intf.isUARTEnabled, intf.isI2CEnabled, intf.isDigitalIOEnabled, intf.isUART2Enabled, intf.isButtonEnabled);
    }

    public byte[] Interface(byte bitFlag)
    {
        byte[] param = new byte[6];
        int size = 0;

        //パラメータのセット
        param[size++] = 0x2E; // Interfaceコマンド

        GetIDBytes().CopyTo(param, size);
        size += 2;

        param[size++] = bitFlag; //ビットフラグ

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] SafetySettings(byte bitFlag)
    {
        byte[] param = new byte[6];
        int size = 0;

        //パラメータのセット
        param[size++] = 0x32; //SafetySettings コマンド

        GetIDBytes().CopyTo(param, size);
        size += 2;

        param[size++] = bitFlag; //ビットフラグ

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] LimitCurrent(float current)
    {
        byte[] param = new byte[9];
        int size = 0;

        param[size++] = 0x33;

        GetIDBytes().CopyTo(param, size);
        size += 2;

        byte[] array = FloatToBytes(current);
        array.CopyTo(param, size);
        size += 4;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] UARTBaudRate(byte rate)
    {
        byte[] param = new byte[6];
        int size = 0;

        //パラメータのセット
        param[size++] = 0xC3;

        GetIDBytes().CopyTo(param, size);
        size += 2;

        param[size++] = rate; //ビットフラグ

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] I2CAddress(byte address)
    {
        byte[] param = new byte[6];
        int size = 0;

        //パラメータのセット
        param[size++] = 0xC0;

        GetIDBytes().CopyTo(param, size);
        size += 2;

        param[size++] = address; //ビットフラグ

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }


    public byte[] SaveAllRegisters()
    {
        byte[] param = new byte[5];
        int size = 0;

        param[size++] = 0x41; //saveAllRegisters

        GetIDBytes().CopyTo(param, size);
        size += 2;


        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        System.Threading.Thread.Sleep(3000);
        return param;
    }

    public byte[] ResetAllRegisters()
    {
        byte[] param = new byte[5];
        int size = 0;

        param[size++] = 0x4F;

        GetIDBytes().CopyTo(param, size);
        size += 2;


        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        System.Threading.Thread.Sleep(500);
        return param;
    }

    public byte[] EnableIMUMeasuement()
    {
        byte[] param = new byte[5];
        int size = 0;

        param[size++] = 0xEA;

        GetIDBytes().CopyTo(param, size);
        size += 2;


        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }


    public byte[] DisableIMUMeasuement()
    {
        byte[] param = new byte[5];
        int size = 0;

        param[size++] = 0xEB;

        GetIDBytes().CopyTo(param, size);
        size += 2;


        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }



    public byte[] EnterDFU()
    {
        byte[] param = { 0xFD, 0x00, 0x00, 0x4B, 0x73 };


        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, 5);
        }
        return param;
    }

    public byte[] Disable()
    {
        byte[] param = new byte[5];
        int size = 0;

        param[size++] = 0x50; //disable 

        GetIDBytes().CopyTo(param, size);
        size += 2;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] Enable()
    {
        byte[] param = new byte[5];
        int size = 0;

        //パラメータのセット
        param[size++] = 0x51; //enable コマンド

        GetIDBytes().CopyTo(param, size);
        size += 2;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            Console.WriteLine(string.Join(", ", param));
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] DisableActionTask()
    {
        byte[] param = new byte[5];
        int size = 0;

        param[size++] = 0x6A; //disable 

        GetIDBytes().CopyTo(param, size);
        size += 2;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] EnableActionTask()
    {
        byte[] param = new byte[5];
        int size = 0;

        //パラメータのセット
        param[size++] = 0x6B; //enable コマンド

        GetIDBytes().CopyTo(param, size);
        size += 2;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            Console.WriteLine(string.Join(", ", param));
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] Speed(float value)
    {
        byte[] param = new byte[9];
        int size = 0;

        // Windows PC　はリトルエンディアンであることに注意。ビッグエンディアンにしてバイト列にする。
        byte[] spdArray = FloatToBytes(value);

        //パラメータのセット
        param[size++] = 0x58; //speed コマンド

        GetIDBytes().CopyTo(param, size);
        size += 2;

        spdArray.CopyTo(param, size);
        size += 4;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] SpeedRpm(float rpm)
    {
        return Speed(rpm * (float)(2 * Math.PI / 60));
    }

    public byte[] PresetPosition(float value)
    {
        byte[] param = new byte[9];
        int size = 0;

        byte[] spdArray = FloatToBytes(value);

        param[size++] = 0x5A;

        GetIDBytes().CopyTo(param, size);
        size += 2;

        spdArray.CopyTo(param, size);
        size += 4;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] PresetPositionDegree(float degree)
    {
        return PresetPosition(degree * (float)(Math.PI / 180));
    }


    public byte[] RunForward()
    {
        byte[] param = new byte[5];
        int size = 0;

        param[size++] = 0x60; //runForward コマンド
        GetIDBytes().CopyTo(param, size);
        size += 2;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] RunReverse()
    {
        byte[] param = new byte[5];
        int size = 0;

        //パラメータのセット
        param[size++] = 0x61; //runReverse コマンド
        GetIDBytes().CopyTo(param, size);
        size += 2;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        //サーボの書き込み
        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }


    public byte[] RunAtVelocityRpm(float value)
    {
        return RunAtVelocity(value * (float)(2*Math.PI / 60));
    }

    public byte[] RunAtVelocity(float value)
    {
        byte[] param = new byte[9];
        int size = 0;

        byte[] spdArray = FloatToBytes(value);

        param[size++] = 0x62;
        GetIDBytes().CopyTo(param, size);
        size += 2;

        spdArray.CopyTo(param, size);
        size += 4;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }


    public byte[] MoveToPosition(float value)
    {
        byte[] param = new byte[9];
        int size = 0;

        byte[] spdArray = FloatToBytes(value);

        param[size++] = 0x66; //moveToPosition コマンド
        GetIDBytes().CopyTo(param, size);
        size += 2;

        spdArray.CopyTo(param, size);
        size += 4;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }
    public byte[] MoveToPositionWait(float value)
    {
        byte[] param = new byte[9];
        int size = 0;

        byte[] spdArray = FloatToBytes(value);

        param[size++] = 0x76; //moveToPosition コマンド
        GetIDBytes().CopyTo(param, size);
        size += 2;

        spdArray.CopyTo(param, size);
        size += 4;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] MoveToPositionDegree(float degree)
    {
        return MoveToPosition(degree * (float)(Math.PI / 180));
    }

    public byte[] MoveToPositionDegreeWait(float degree)
    {
        return MoveToPositionWait(degree * (float)(Math.PI / 180));
    }

    public byte[] MoveByDistance(float value)
    {
        byte[] param = new byte[9];
        int size = 0;

        byte[] spdArray = FloatToBytes(value);

        param[size++] = 0x68; //moveByDistance 
        GetIDBytes().CopyTo(param, size);
        size += 2;

        spdArray.CopyTo(param, size);
        size += 4;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] MoveByDistanceWait(float value)
    {
        byte[] param = new byte[9];
        int size = 0;

        byte[] spdArray = FloatToBytes(value);

        param[size++] = 0x78; //moveByDistance 
        GetIDBytes().CopyTo(param, size);
        size += 2;

        spdArray.CopyTo(param, size);
        size += 4;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] MoveByDistanceDegree(float degree)
    {
        return MoveByDistance(degree * (float)(Math.PI / 180));
    }

    public byte[] MoveByDistanceDegreeWait(float degree)
    {
        return MoveByDistanceWait(degree * (float)(Math.PI / 180));
    }


    public byte[] Free()
    {
        byte[] param = new byte[5];
        int size = 0;

        //パラメータのセット
        param[size++] = 0x6C; //free コマンド
        GetIDBytes().CopyTo(param, size);
        size += 2;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] Stop()
    {
        byte[] param = new byte[5];
        int size = 0;

        //パラメータのセット
        param[size++] = 0x6D; //stop コマンド
        GetIDBytes().CopyTo(param, size);
        size += 2;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }


    public byte[] HoldTorque(float value)
    {
        byte[] param = new byte[9];
        int size = 0;

        byte[] spdArray = FloatToBytes(value);

        param[size++] = 0x72;
        GetIDBytes().CopyTo(param, size);
        size += 2;

        spdArray.CopyTo(param, size);
        size += 4;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] WaitQueue(UInt32 msec)
    {
        byte[] param = new byte[9];
        int size = 0;

        // Windows PC　はリトルエンディアンであることに注意。ビッグエンディアンにしてバイト列にする。
        byte[] dataArray = UInt32ToBytes(msec);

        //パラメータのセット
        param[size++] = 0x92; // コマンド

        GetIDBytes().CopyTo(param, size);
        size += 2;

        dataArray.CopyTo(param, size);
        size += 4;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] WaitQueueUntilInput(byte pin, byte edge = 2, UInt32 timeout = 0, byte sub_pin1 = 0xFF, byte sub_state1 = 0, byte sub_pin2 = 0xFF, byte sub_state2 = 0, byte sub_pin3 = 0xFF, byte sub_state3 = 0)
    {
        byte[] param = new byte[17];
        int size = 0;

        // Windows PC　はリトルエンディアンであることに注意。ビッグエンディアンにしてバイト列にする。
        byte[] dataArray = UInt32ToBytes(timeout);

        //パラメータのセット
        param[size++] = 0x96; // コマンド

        GetIDBytes().CopyTo(param, size);
        size += 2;

        param[size++] = pin;
        param[size++] = edge;

        dataArray.CopyTo(param, size);
        size += 4;

        param[size++] = sub_pin1;
        param[size++] = sub_state1;
        param[size++] = sub_pin2;
        param[size++] = sub_state2;
        param[size++] = sub_pin3;
        param[size++] = sub_state3;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] TriggerTasksetSettings(UInt16 index, UInt32 repeating)
    {
        byte[] param = new byte[11];
        int size = 0;

        // Windows PC　はリトルエンディアンであることに注意。ビッグエンディアンにしてバイト列にする。
        byte[] indexArray = UInt16ToBytes(index);
        byte[] repeatArray = UInt32ToBytes(repeating);

        //パラメータのセット
        param[size++] = 0xA8; // コマンド

        GetIDBytes().CopyTo(param, size);
        size += 2;

        indexArray.CopyTo(param, size);
        size += 2;

        repeatArray.CopyTo(param, size);
        size += 4;


        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;

    }


    public byte[] TriggerMotionSettings(UInt16 index, UInt32 repeating, PlaybackOption option, Boolean auto_start)
    {
        byte[] param = new byte[13];
        int size = 0;

        // Windows PC　はリトルエンディアンであることに注意。ビッグエンディアンにしてバイト列にする。
        byte[] indexArray = UInt16ToBytes(index);
        byte[] repeatArray = UInt32ToBytes(repeating);

        //パラメータのセット
        param[size++] = 0xB2; // コマンド

        GetIDBytes().CopyTo(param, size);
        size += 2;

        indexArray.CopyTo(param, size);
        size += 2;

        repeatArray.CopyTo(param, size);
        size += 4;

        param[size++] = (byte)option;
        param[size++] = auto_start ? (byte)1 : (byte)0;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] AutoStartSetting(Byte mode)
    {
        byte[] param = new byte[6];
        int size = 0;

        //パラメータのセット
        param[size++] = 0xBC; // コマンド


        GetIDBytes().CopyTo(param, size);
        size += 2;

        param[size++] = mode;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] ButtonSetting(Byte mode)
    {
        byte[] param = new byte[6];
        int size = 0;

        //パラメータのセット
        param[size++] = 0xBD; // コマンド


        GetIDBytes().CopyTo(param, size);
        size += 2;

        param[size++] = mode;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    /*
     * Teaching Playback 
     * 
     */

    public byte[] EraseMotion(UInt16 index)
    {
        byte[] param = new byte[7];
        int size = 0;

        // Windows PC　はリトルエンディアンであることに注意。ビッグエンディアンにしてバイト列にする。
        byte[] indexArray = UInt16ToBytes(index);

        //パラメータのセット
        param[size++] = 0xAD; // コマンド

        GetIDBytes().CopyTo(param, size);
        size += 2;

        indexArray.CopyTo(param, size);
        size += 2;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] EraseAllMotion()
    {
        byte[] param = new byte[5];
        int size = 0;

        //パラメータのセット
        param[size++] = 0xAE; // コマンド
        GetIDBytes().CopyTo(param, size);
        size += 2;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }


    public byte[] PrepareTeachingMotion(UInt16 index, UInt32 time)
    {
        byte[] param = new byte[11];
        int size = 0;

        // Windows PC　はリトルエンディアンであることに注意。ビッグエンディアンにしてバイト列にする。
        byte[] indexArray = UInt16ToBytes(index);
        byte[] timeArray = UInt32ToBytes(time);

        //パラメータのセット
        param[size++] = 0xAA; // コマンド

        GetIDBytes().CopyTo(param, size);
        size += 2;

        indexArray.CopyTo(param, size);
        size += 2;

        timeArray.CopyTo(param, size);
        size += 4;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] StartTeachingMotionFromPrep()
    {
        byte[] param = new byte[5];
        int size = 0;

        //パラメータのセット
        param[size++] = 0xAB; // コマンド
        GetIDBytes().CopyTo(param, size);
        size += 2;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] StopTeachingMotion()
    {
        byte[] param = new byte[5];
        int size = 0;

        //パラメータのセット
        param[size++] = 0xAC; // コマンド
        GetIDBytes().CopyTo(param, size);
        size += 2;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] ReadMotion(UInt16 index)
    {
        byte[] param = new byte[7];
        int size = 0;

        // Windows PC　はリトルエンディアンであることに注意。ビッグエンディアンにしてバイト列にする。
        byte[] indexArray = UInt16ToBytes(index);

        //パラメータのセット
        param[size++] = 0xB7; // コマンド

        GetIDBytes().CopyTo(param, size);
        size += 2;

        indexArray.CopyTo(param, size);
        size += 2;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] WriteMotionPosition(float value)
    {
        byte[] param = new byte[9];
        int size = 0;

        byte[] spdArray = FloatToBytes(value);

        param[size++] = 0xB8; //moveByDistance 
        GetIDBytes().CopyTo(param, size);
        size += 2;

        spdArray.CopyTo(param, size);
        size += 4;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] StartDoingTaskset(UInt16 index, UInt32 repeating)
    {
        byte[] param = new byte[11];
        int size = 0;

        // Windows PC　はリトルエンディアンであることに注意。ビッグエンディアンにしてバイト列にする。
        byte[] indexArray = UInt16ToBytes(index);
        byte[] repeatArray = UInt32ToBytes(repeating);

        //パラメータのセット
        param[size++] = 0x81; // コマンド

        GetIDBytes().CopyTo(param, size);
        size += 2;

        indexArray.CopyTo(param, size);
        size += 2;

        repeatArray.CopyTo(param, size);
        size += 4;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] StopDoingTaskset()
    {
        byte[] param = new byte[5];
        int size = 0;

        //パラメータのセット
        param[size++] = 0x82; // コマンド
        GetIDBytes().CopyTo(param, size);
        size += 2;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }


    // playback 開始地点の列挙子
    public enum PlaybackOption
    {
        StartFromRawRepeatWithBack = 0,
        StartFromCurrentRepeatWithBack = 1,
        StartFromRawRepeatWithoutBack = 2,
        StartFromCurrentRepeatWithoutBack = 3
    }

    public byte[] StartPlaybackMotion(UInt16 index, UInt32 repeating, PlaybackOption option)
    {
        byte[] param = new byte[12];
        int size = 0;

        // Windows PC　はリトルエンディアンであることに注意。ビッグエンディアンにしてバイト列にする。
        byte[] indexArray = UInt16ToBytes(index);
        byte[] repeatArray = UInt32ToBytes(repeating);

        //パラメータのセット
        param[size++] = 0x85; // コマンド

        GetIDBytes().CopyTo(param, size);
        size += 2;

        indexArray.CopyTo(param, size);
        size += 2;

        repeatArray.CopyTo(param, size);
        size += 4;

        param[size++] = (byte)option;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] PreparePlaybackMotion(UInt16 index, UInt32 repeating, PlaybackOption option)
    {
        byte[] param = new byte[12];
        int size = 0;

        // Windows PC　はリトルエンディアンであることに注意。ビッグエンディアンにしてバイト列にする。
        byte[] indexArray = UInt16ToBytes(index);
        byte[] repeatArray = UInt32ToBytes(repeating);

        //パラメータのセット
        param[size++] = 0x86; // コマンド

        GetIDBytes().CopyTo(param, size);
        size += 2;

        indexArray.CopyTo(param, size);
        size += 2;

        repeatArray.CopyTo(param, size);
        size += 4;

        param[size++] = (byte)option;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] StartPlaybackMotionFromPrep()
    {
        byte[] param = new byte[5];
        int size = 0;

        //パラメータのセット
        param[size++] = 0x87; // コマンド
        GetIDBytes().CopyTo(param, size);
        size += 2;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] StopPlaybackMotion()
    {
        byte[] param = new byte[5];
        int size = 0;

        //パラメータのセット
        param[size++] = 0x88; // コマンド
        GetIDBytes().CopyTo(param, size);
        size += 2;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] EraseTaskset(UInt16 index)
    {
        byte[] param = new byte[7];
        int size = 0;

        // Windows PC　はリトルエンディアンであることに注意。ビッグエンディアンにしてバイト列にする。
        byte[] indexArray = UInt16ToBytes(index);

        //パラメータのセット
        param[size++] = 0xA3; // コマンド

        GetIDBytes().CopyTo(param, size);
        size += 2;

        indexArray.CopyTo(param, size);
        size += 2;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] EraseAllTasksets()
    {
        byte[] param = new byte[5];
        int size = 0;

        //パラメータのセット
        param[size++] = 0xA4; // コマンド
        GetIDBytes().CopyTo(param, size);
        size += 2;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] StartRecordingTaskset(UInt16 index)
    {
        byte[] param = new byte[7];
        int size = 0;

        // Windows PC　はリトルエンディアンであることに注意。ビッグエンディアンにしてバイト列にする。
        byte[] indexArray = UInt16ToBytes(index);

        //パラメータのセット
        param[size++] = 0xA0; // コマンド

        GetIDBytes().CopyTo(param, size);
        size += 2;

        indexArray.CopyTo(param, size);
        size += 2;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] StopRecordingTaskset()
    {
        byte[] param = new byte[5];
        int size = 0;

        //パラメータのセット
        param[size++] = 0xA2; // コマンド
        GetIDBytes().CopyTo(param, size);
        size += 2;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    /* 
     * Registers
     */

    public byte[] TeachingInterval(UInt32 interval)
    {
        byte[] param = new byte[9];
        int size = 0;

        // Windows PC　はリトルエンディアンであることに注意。ビッグエンディアンにしてバイト列にする。
        byte[] intvlArray = UInt32ToBytes(interval);

        //パラメータのセット
        param[size++] = 0x16; // コマンド

        GetIDBytes().CopyTo(param, size);
        size += 2;

        intvlArray.CopyTo(param, size);
        size += 4;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] PlaybackInterval(UInt32 interval)
    {
        byte[] param = new byte[9];
        int size = 0;

        // Windows PC　はリトルエンディアンであることに注意。ビッグエンディアンにしてバイト列にする。
        byte[] intvlArray = UInt32ToBytes(interval);

        //パラメータのセット
        param[size++] = 0x17; // コマンド

        GetIDBytes().CopyTo(param, size);
        size += 2;

        intvlArray.CopyTo(param, size);
        size += 4;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    /*
     *      
        Set the notification interval of motor measurement values. It is valid only for USB(UART) and BLE.
        In case of BLE, the allowed minimum value is 100 [ms]. 
        
        flag: interval[ms]
        -----------
        0:      2 [ms]
        1:      5 [ms]
        2:     10 [ms]
        3:     20 [ms]
        4:     50 [ms]
        5:    100 [ms]
        6:    200 [ms]
        7:    500 [ms]
        8:   1000 [ms]
        9:   2000 [ms]
        10:  5000 [ms]
        11: 10000 [ms]
        -----------        
     */
    public byte[] MotorMeasurementInterval(Byte flag)
    {
        byte[] param = new byte[6];
        int size = 0;

        //パラメータのセット
        param[size++] = 0x2C; // コマンド


        GetIDBytes().CopyTo(param, size);
        size += 2;

        param[size++] = flag;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    /*
     *            
        Set the notification interval of IMU measurement values. It is valid only for USB(UART) and BLE.
        In case of BLE, the allowed minimum value is 100 [ms]. 
        flag: interval[ms]
        -----------
        0:     10 [ms]
        1:     20 [ms]
        2:     50 [ms]
        3:    100 [ms]
        4:    200 [ms]
        5:    500 [ms]
        6:   1000 [ms]
        7:   2000 [ms]
        9:   5000 [ms]
        10: 10000 [ms]
        -----------      
     */
    public byte[] IMUmeasurementInterval(Byte flag)
    {
        byte[] param = new byte[6];
        int size = 0;

        //パラメータのセット
        param[size++] = 0x3C; // コマンド


        GetIDBytes().CopyTo(param, size);
        size += 2;

        param[size++] = flag;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }


    /*
     * Read  
     *  
     */
    public byte[] ReadMotorMeasurement()
    {
        byte[] param = new byte[5];
        int size = 0;

        //パラメータのセット
        param[size++] = 0xB4; // コマンド
        GetIDBytes().CopyTo(param, size);
        size += 2;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] ReadStatus()
    {
        byte[] param = new byte[5];
        int size = 0;

        //パラメータのセット
        param[size++] = 0x9A; // コマンド
        GetIDBytes().CopyTo(param, size);
        size += 2;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }


    public byte[] ReadRegister(Byte register)
    {
        byte[] param = new byte[6];
        int size = 0;

        //パラメータのセット
        param[size++] = 0x40; // コマンド

        GetIDBytes().CopyTo(param, size);
        size += 2;

        param[size++] = register;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        System.Threading.Thread.Sleep(30); // 値取得まで待機
        return param;
    }


    public InterfaceSetting ReadInterface()
    {
        ReadRegister(0x2E);
        
        return interfaceSetting;

    }

    public String ReadDeviceName()
    {
        ReadRegister(0x46);
        return deviceName;
    }

    public String ReadDeviceInfo()
    {
        ReadRegister(0x47);
        return deviceInfo;
    }

    public float ReadSpeedP()
    {
        ReadRegister(0x1B);
        return speedP;
    }

    public float ReadSpeedI()
    {
        ReadRegister(0x1C);
        return speedI;
    }

    public float ReadSpeedD()
    {
        ReadRegister(0x1C);
        return speedD;
    }

    public float ReadPositionP()
    {
        ReadRegister(0x1E);
        return positionP;
    }

    public float ReadPositionI()
    {
        ReadRegister(0x1F);
        return positionI;
    }

    public float ReadPositionD()
    {
        ReadRegister(0x20);
        return positionD;
    }

    public float ReadPosPIDThreshold()
    {
        ReadRegister(0x21);
        return positionPIDThreshold;
    }

    public (bool, float, UInt32) ReadPosArrivalSetting()
    {
        ReadRegister(0x2B);
        return (notifyPosArrival, posArrivalTolerance, posArrivalJudgeTime);
    }


    /*
     * LED  
     *  
     */


    // LED状態の列挙子
    public enum LedState
    {
        Off,
        OnSolid,
        OnFlash,
        OnDim
    }

    public byte[] Led(LedState state, byte red, byte green, byte blue)
    {
        byte[] param = new byte[9];
        int size = 0;

        //パラメータのセット
        param[size++] = 0xE0; //LED コマンド
        GetIDBytes().CopyTo(param, size);
        size += 2;
        param[size++] = (byte)state; // LedState
        param[size++] = red; //RGB
        param[size++] = green; //RGB
        param[size++] = blue; //RGB

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            Console.WriteLine("serialPort.IsOpen");
            serialPort.Write(param, 0, size);
        } else
        {
            Console.WriteLine("serialPort.Is not Open");
        }
        Console.WriteLine(param);
        return param;
    }


    /*
     * Others
     */
    public byte[] Reboot()
    {
        byte[] param = new byte[5];
        int size = 0;

        //パラメータのセット
        param[size++] = 0xF0; // コマンド
        GetIDBytes().CopyTo(param, size);
        size += 2;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }

    public byte[] EnableCheckSum(bool isEnabled)
    {
        byte[] param = new byte[6];
        int size = 0;

        //パラメータのセット
        param[size++] = 0xF3; // コマンド
        GetIDBytes().CopyTo(param, size);
        size += 2;

        param[size++] = isEnabled ? (byte)1 : (byte)0;

        GetCRC16Bytes(param, size).CopyTo(param, size);
        size += 2;

        if (serialPort.IsOpen == true)
        {
            serialPort.Write(param, 0, size);
        }
        return param;
    }



}
